routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Route::get('/test', function() {
// 	$cookie = Cookie::forever('imfo_views', 'SuperAdmin');
// 	return response('SuperAdmin SetCookie')->cookie($cookie);
// });

// Basic Routes
Route::get('/', 'WelcomeController@index')->name('welcome');
Route::get('/about', 'BasicController@about')->name('about');
Route::get('/contact', 'BasicController@contact')->name('contact');
Route::post('/contact', 'BasicController@contactSend')->name('contact.send');
Route::get('/disclaimer', 'BasicController@disclaimer')->name('disclaimer');

Route::get('/img/{name}', 'BasicController@images')->name('images')->where('name', '.*');

// Blogs Routes
Route::get('/blogs', 'BlogsController@index')->name('blogs.index');
Route::get('/blogs/{slug}', 'BlogsController@view')->name('blogs.view');

// Posts Routes
Route::get('/posts', 'PostsController@index')->name('posts.index');
Route::get('/posts/{catSlug}', 'PostsController@catePage')->name('posts.cate.page');
Route::get('/posts/{catSlug}/{skeSlug}', 'PostsController@pageShare')->name('posts.page.share');

// Cate Routes
Route::get('/cate', 'CateController@index')->name('cate.index');
Route::get('/cate/{slug}', 'CateController@page')->name('cate.page');
Route::get('/cate/{slug}/{skeSlug}', 'CateController@pageShare')->name('cate.page.share');

// Auth::routes();

// Route::get('/home', 'HomeController@index')->name('home');

// Middleware
// Route::middleware(['auth:web'])->group(function () {
// 	Route::get('/user', 'UserController@index')->name('user.index');
// 	Route::get('/user/sketchs/create', 'UserController@sketchsCreate')->name('user.sketchs.create');
// 	Route::post('/user/sketchs/create', 'UserController@sketchsStore')->name('user.sketchs.store');
// 	Route::get('/user/sketchs/view', 'UserController@sketchsView')->name('user.sketchs.view');
// 	Route::get('/user/sketchs/{id}', 'UserController@sketchsById')->name('user.sketchs.byId');

// });

// oversight
Route::middleware(['auth:oversight'])->group(function () {
	Route::get('/about/edit', 'BasicController@aboutEdit')->name('about.edit');
	// Route::get('/disclaimer/edit', 'BasicController@disclaimerEdit')->name('disclaimer.edit');
	Route::post('/about/edit', 'BasicController@aboutUpdate')->name('about.update');
	// Route::post('/disclaimer/edit', 'BasicController@disclaimerUpdate')->name('disclaimer.update');
});

Route::prefix('oversight')->namespace('Oversight')->name('oversight.')->group(function () {

	Route::get('/login', 'Auth\LoginController@showLoginForm')->name('login');
	Route::post('/login', 'Auth\LoginController@login')->name('login.post');
	Route::post('/logout', 'Auth\LoginController@logout')->name('logout');

	// Middleware
	Route::middleware(['auth:oversight'])->group(function () {

		Route::get('/', 'DashboardController@index')->name('dashboard');

		Route::post('/upload', 'DashboardController@upload')->name('upload');
		Route::get('/storage', 'DashboardController@storage')->name('storage');

		Route::get('/websites', 'WebsiteIconController@websites')->name('websites');
		Route::post('/websites/store', 'WebsiteIconController@store_website_url')->name('store_website_url');
		Route::get('/website_icons', 'WebsiteIconController@website_icons')->name('website_icons');

		Route::post('/sketchs/datatable', 'SketchController@datatable')->name('sketchs.datatable');
		Route::post('/sketchs/is_active/{id}', 'SketchController@isActive')->name('sketchs.isActive');

		Route::post('/blogs/datatable', 'BlogController@datatable')->name('blogs.datatable');
		Route::post('/blogs/is_active/{id}', 'BlogController@isActive')->name('blogs.isActive');

		Route::resource('/blogs', 'BlogController')->parameters([
			'blogs' => 'id'
		]);
		Route::resource('/sketchs', 'SketchController')->parameters([
			'sketchs' => 'id'
		]);
		Route::resource('/categories', 'CategoryController')->parameters([
			'categories' => 'id',
		]);
		Route::resource('/website_icon', 'WebsiteIconController')->parameters([
			'website_icon' => 'id',
		]);

	});

});

app/Models/Category.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Category extends Model
{
	/**
	 * The attributes that are mass assignable.
	 *
	 * @var array
	 */
	protected $fillable = [
		'name', 'slug'
	];

}

app/Http/Controllers/Oversight/BlogController.php
<?php

namespace App\Http\Controllers\Oversight;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\Blog;
use Illuminate\Http\File;
use Illuminate\Support\Facades\Storage;
use Yajra\Datatables\Datatables;

class BlogController extends Controller
{
	/**
	 * Display a listing of the resource.
	 *
	 * @return \Illuminate\Http\Response
	 */
	public function index()
	{
		return view('oversight.blogs.index');
	}

	/**
	 * Show the form for creating a new resource.
	 *
	 * @return \Illuminate\Http\Response
	 */
	public function create()
	{
		return view('oversight.blogs.create');
	}

	/**
	 * Store a newly created resource in storage.
	 *
	 * @param  \Illuminate\Http\Request  $request
	 * @return \Illuminate\Http\Response
	 */
	public function store(Request $request)
	{
		$request->validate(
			[
				'title' => 'required|string|unique:blogs,title',
				'image' => 'required|image|max:2000',
				'content' => 'required|min:200',
			]
		);

		$blank = "<p><br></p>";
		
		$content = $request->content;
		$title = $request->title;
		$image = $request->image;
		$slug = str_slug($request->title);

		if ($content == $blank) {

			return redirect()->back();

		} else {

			$created_by = auth('oversight')->user()->id;
			$path = 'blogs/'.date("Y").'/';

			$data = [
				'title' => $title,
				'slug' => $slug,
				'path' => $path,
				'image' => $image->hashName(),
				'content' => $content,
				'created_by' => $created_by,
			];

			$blog = Blog::create($data);

			Storage::disk('public')->put($path, $image);

			$request->session()->flash('success', 'Submit Blog Successfully!');
			return route('oversight.blogs.show', $blog->id);

		}
	}

	/**
	 * Display the specified resource.
	 *
	 * @param  int  $id
	 * @return \Illuminate\Http\Response
	 */
	public function show($id)
	{
		$blog = Blog::findOrFail($id);

		return view('oversight.blogs.show', compact('blog'));
	}

	/**
	 * Show the form for editing the specified resource.
	 *
	 * @param  int  $id
	 * @return \Illuminate\Http\Response
	 */
	public function edit($id)
	{
		$blog = Blog::findOrFail($id);

		return view('oversight.blogs.edit', compact('blog'));
	}

	/**
	 * Update the specified resource in storage.
	 *
	 * @param  \Illuminate\Http\Request  $request
	 * @param  int  $id
	 * @return \Illuminate\Http\Response
	 */
	public function update(Request $request, $id)
	{
		$request->validate(
			[
				'title' => 'required|string|unique:blogs,title,'.$id,
				'image' => 'image|max:2000',
				'content' => 'required|min:200',
			]
		);

		$blank = "<p><br></p>";
		
		$content = $request->content;
		$title = $request->title;
		$image = $request->image;
		$slug = str_slug($request->title);


		if ($content == $blank) {

			return redirect()->back();

		} else {

			$blog = Blog::findOrFail($id);

			$data = [
				'title' => $title,
				'slug' => $slug,
				'content' => $content,
			];

			if ($image) {

				if(!$blog->image) {
					$path = 'blogs/'.date("Y").'/';
					$data = $data + [
						'path' => $path,
					];
				}

				$data = $data + [
					'image' => $image->hashName(),
				];

			}

			$blog->update($data);

			if ($image) {

				Storage::disk('public')->putFileAs($blog->path, new File($image), $blog->image);

			}

			$request->session()->flash('success', 'Update Blog Successfully!');
			return route('oversight.blogs.show', $id);

		}
	}

	/**
	 * Remove the specified resource from storage.
	 *
	 * @param  int  $id
	 * @return \Illuminate\Http\Response
	 */
	public function destroy($id)
	{

		Blog::destroy($id);

		if (request()->ajax()) {

			return 'TRUE';

		} else {

			return redirect()->route('oversight.blogs.index')->with('success', 'Blog Deleted!');

		}

	}

	public function datatable()
	{
		$blogs = Blog::query();

		return Datatables::of($blogs)
		->addColumn('action', function ($blogs) {
			$button = '<div class="row text-center">
				<a href="'.route('oversight.blogs.edit', $blogs->id).'" class="col-sm-6">
					<i class="material-icons">border_color</i>
				</a>
				<span onclick="openDeleteModal('.$blogs->id.')" class="col-sm-6">
					<img style="width: 30px;height: 30px;" src="'.asset("svg/delete.svg").'">
				</span>
			</div>';
			return $button;
		})
		->editColumn('id', function($blogs) {
			return '<a href="'.route('oversight.blogs.show', $blogs->id).'" target="_blank">'.$blogs->id.'</a>';
		})
		->editColumn('image', function($blogs) {
			return '<img src="'.$blogs->image_path.'" class="img-fluid">';
		})
		->editColumn('title', function($blogs) {
			return str_limit($blogs->title, 50);
		})
		->editColumn('is_active', function($blogs) {
			$button = '<label class="switch">
				<input type="checkbox" '. (($blogs->is_active == '1') ? 'checked' : '') .' onchange="isActive('.$blogs->id.', event)">
				<span class="slider"></span>
			</label>';
			return $button;
		})
		->editColumn('created_at', function($blogs) {
			return $blogs->created_at->format('M d, Y (h:i:s A)');
		})
		->setRowClass(function ($blogs){
			return $blogs->is_active == '0' ? 'table-danger' : '' ;
		})
		->setRowId(function ($blogs) {
			return 'sketch_'.$blogs->id;
		})
		->rawColumns(['id', 'image', 'action', 'is_active'])
		->make(true);
	}

	public function isActive(Request $request, $id)
	{
		$check = ($request->check === 'true') ? '1' : '0';

		$data = [
			'is_active' => $check,
		];

		Blog::findOrFail($id)->update($data);
	}

}

app/Http/Controllers/Oversight/CategoryController.php
<?php

namespace App\Http\Controllers\Oversight;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\Category;
use Illuminate\Validation\Rule;

class CategoryController extends Controller
{
	/**
	 * Display a listing of the resource.
	 *
	 * @return \Illuminate\Http\Response
	 */
	public function index()
	{
		$categories = Category::all();
		return view('oversight.categories.index', compact('categories'));
	}

	/**
	 * Show the form for creating a new resource.
	 *
	 * @return \Illuminate\Http\Response
	 */
	public function create()
	{
		//
	}

	/**
	 * Store a newly created resource in storage.
	 *
	 * @param  \Illuminate\Http\Request  $request
	 * @return \Illuminate\Http\Response
	 */
	public function store(Request $request)
	{
		$request->validate(
			[
				'name' => 'required|string|unique:categories,name',
			]
		);


		$name = ucwords($request->name);
		$slug = str_slug($name, '_');

		$data = [
			'name' => $name,
			'slug' => $slug,
		];

		return Category::firstOrCreate($data,['name' => $name]);

	}

	/**
	 * Display the specified resource.
	 *
	 * @param  int  $id
	 * @return \Illuminate\Http\Response
	 */
	public function show($id)
	{
		//
	}

	/**
	 * Show the form for editing the specified resource.
	 *
	 * @param  int  $id
	 * @return \Illuminate\Http\Response
	 */
	public function edit($id)
	{
		//
	}

	/**
	 * Update the specified resource in storage.
	 *
	 * @param  \Illuminate\Http\Request  $request
	 * @param  int  $id
	 * @return \Illuminate\Http\Response
	 */
	public function update(Request $request, $id)
	{

		// $request->merge([
		// 	'title' => "google",
		// ]);
		$request->validate(
			[
				'name' => [
					'required',
					'string',
					Rule::unique('categories', 'name')->ignore($id),
					function ($attribute, $value, $fail) use ($id) {
						if(!Category::find($id)) {
							$fail('No record find.');
						}
					},
				]
			]
		);

		$name = ucwords($request->name);
		$slug = str_slug($name, '_');

		$data = [
			'name' => $name,
			'slug' => $slug,
		];

		Category::find($id)->update($data);

		return Category::find($id);

	}

	/**
	 * Remove the specified resource from storage.
	 *
	 * @param  int  $id
	 * @return \Illuminate\Http\Response
	 */
	public function destroy($id)
	{
		//
	}
}

app/Http/Controllers/Oversight/DashboardController.php
<?php

namespace App\Http\Controllers\Oversight;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\Sketch;
use Illuminate\Support\Facades\Storage;
use InterventionImage;

class DashboardController extends Controller
{
	/**
	 * Display a listing of the resource.
	 *
	 * @return \Illuminate\Http\Response
	 */
	public function index()
	{
		$sketch = new Sketch;

		$sketch->total = $sketch->count();
		$sketch->active = $sketch->where('is_active', '1')->count();
		$sketch->inActive = $sketch->total - $sketch->active;

		return view('oversight.dashboard', compact('sketch'));
	}

	public function upload(Request $request)
	{
		$request->validate(
			[
				'upload' => ['required', 'image', 'max:2000'],
			],
			[
				'upload.max' => 'Maximum Image size to upload is 2MB.',
			],
			[
				'upload' => 'Image',
			]

		);

		// Get Image
		$image = $request->upload;

		// Set Path
		$path = 'content/'.date('Y').'/';

		$fullPath = '/storage/'.$path.$image->hashName();

		$this->resizeImage($image);

		Storage::disk('public')->put($path, $image);

		$data = [
			'url' => $fullPath,
		];

		// Make response
		return response()->json($data);
	}

	public function storage(Request $request)
	{
		return view('oversight.storage');
	}

	public function resizeImage($image)
	{
		$imageSize = getimagesize($image);
		$height = $imageSize[1];

		$imageObj = InterventionImage::make($image);

		if ($height > 600) {

			// resize the image to a height of 200 and constrain aspect ratio (auto width)
			$resizeImage = $imageObj->resize(null, 600, function ($constraint) {
				$constraint->aspectRatio();
			});

			$resizeImage->save($image);

		}

		return true;

	}
}

app/Http/Controllers/Oversight/WebsiteIconController.php
<?php

namespace App\Http\Controllers\Oversight;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\WebsiteIcon;
use App\Models\Website;
use Illuminate\Http\File;
use Illuminate\Support\Facades\Storage;
use InterventionImage;

class WebsiteIconController extends Controller
{
	/**
	 * Display a listing of the resource.
	 *
	 * @return \Illuminate\Http\Response
	 */
	public function index()
	{
		return view('oversight.website_icon.index');
	}

	/**
	 * Show the form for creating a new resource.
	 *
	 * @return \Illuminate\Http\Response
	 */
	public function create()
	{
		//
	}

	/**
	 * Store a newly created resource in storage.
	 *
	 * @param  \Illuminate\Http\Request  $request
	 * @return \Illuminate\Http\Response
	 */
	public function store(Request $request)
	{
		$request->validate(
			[
				'image' => 'required|image|max:2000',
				'title' => 'required|string|unique:website_icons,title',
			]
		);

		// $request->image->path();
		// $request->image->extension();
		// $request->image->clientExtension();
		// $request->image->hashName();

		$image = $request->image;
		$title = $request->title;

		$data = [
			'name' => $image->hashName(),
			'title' => $title,
		];

		$this->resizeIcon($image);

		Storage::disk('public')->put('website_icons', $image);

		return WebsiteIcon::create($data);
	}

	/**
	 * Display the specified resource.
	 *
	 * @param  int  $id
	 * @return \Illuminate\Http\Response
	 */
	public function show($id)
	{
		//
	}

	/**
	 * Show the form for editing the specified resource.
	 *
	 * @param  int  $id
	 * @return \Illuminate\Http\Response
	 */
	public function edit($id)
	{
		//
	}

	/**
	 * Update the specified resource in storage.
	 *
	 * @param  \Illuminate\Http\Request  $request
	 * @param  int  $id
	 * @return \Illuminate\Http\Response
	 */
	public function update(Request $request, $id)
	{
		$request->validate(
			[
				'image' => 'required|image|max:2000',
			]
		);

		$image = $request->image;

		$websiteIcon = WebsiteIcon::findOrFail($id);

		$this->resizeIcon($image);

		return Storage::disk('public')->putFileAs('website_icons', new File($image), $websiteIcon->name);
	}

	/**
	 * Remove the specified resource from storage.
	 *
	 * @param  int  $id
	 * @return \Illuminate\Http\Response
	 */
	public function destroy($id)
	{
		//
	}

	public function websites()
	{
		return Website::orderBy('id', 'desc')->get();
	}

	public function store_website_url(Request $request)
	{
		$request->validate(
			[
				'url' => 'required|string|unique:websites,url',
				'icon' => 'required|numeric|exists:website_icons,id',
			]
		);

		$url = parse_url($request->url, PHP_URL_HOST);
		$icon_id = $request->icon;
		
		$data = [
			'url' => $url,
			'icon_id' => $icon_id,
		];

		return Website::create($data);
	}

	public function website_icons()
	{
		return WebsiteIcon::orderBy('id', 'desc')->get();
	}

	public function resizeIcon($icon)
	{
		$imageSize = getimagesize($icon);
		$height = $imageSize[1];

		$iconObj = InterventionImage::make($icon);

		if ($height >= 50) {

			// resize the icon to a height of 200 and constrain aspect ratio (auto width)
			$resizeIcon = $iconObj->resize(null, 50, function ($constraint) {
				$constraint->aspectRatio();
			});

			$resizeIcon->save($icon);

		}

		return true;

	}
}

resources/views/oversight/categories/index.blade.php
@extends('oversight.layouts.app')

@section('title', 'Categories')

@push('plugins')
@endpush

@section('content')
<div class="content-header">
	<div class="container-fluid">
		<div class="row mb-2">
			<div class="col-sm-6">
				<h1 class="m-0 text-dark">Categories</h1>
			</div>
			<div class="col-sm-6">
				<div class="float-right">
					<button @click="openAdd" class="btn btn-success">Add Category</button>
				</div>
			</div>
		</div>
	</div>
</div>
<!-- /.content-header -->
<!-- Main content -->
<section class="content" v-cloak>
	<div class="container-fluid">
		<div class="row">
			<div class="col-md-12">
				<div class="card card-info card-outline">

					<div class="card-header">
						<div class="row">
							<div class="col-md-6">
								<h3 class="card-title">Handel<small> categories as admin</small></h3>
							</div>
							<div class="col-md-6">
								<div class="card-tools float-right">
									<button type="button" class="btn btn-tool btn-sm" data-widget="collapse" data-toggle="tooltip" title="Collapse">
										<i class="fa fa-minus"></i>
									</button>
								</div>
							</div>
						</div>
					</div>

					<div class="card-body">

						<div class="table-responsive-xl">
							<table class="table">
								<thead>
									<tr>
										<th scope="col">#</th>
										<th scope="col">Name</th>
										<th scope="col">Updated At</th>
										<th scope="col">Action</th>
									</tr>
								</thead>
								<tbody>
									<tr v-for="(value, key, index) in categories" :key="key">
										<th scope="row">@{{ value.id }}</th>
										<td>@{{ value.name }}</td>
										<td>@{{ date_time(value.updated_at) }}</td>
										<td>
											<button class="btn btn-sm btn-primary" @click="openEdit(key)">Edit</button>
										</td>
									</tr>
									<tr v-if="categories.length == 0">
										<td colspan="4" class="text-center">No record found</td>
									</tr>
								</tbody>
							</table>
						</div>

					</div>

				</div>
			</div>
		</div>
	</div>
	<div class="modal fade" id="category" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
		<div class="modal-dialog modal-dialog-centered" role="document">
			<div class="modal-content">
				<div class="modal-header">
					<h5 class="modal-title" id="exampleModalLabel">@{{ modalTitle }}</h5>
					<button type="button" class="close" data-dismiss="modal" aria-label="Close">
						<span aria-hidden="true">&times;</span>
					</button>
				</div>
				<form @submit="categoryForm" :action="action" method="POST">
					<div class="modal-body">
						<div class="form-group my-2">
							<input type="text" class="form-control" name="name" v-model="name" placeholder="Enter category name" autofocus required>
							<span v-if="errors.name" v-for="(value, key) in errors.name" :key="value.id" class="invalid-feedback" role="alert" style="display: flex;">
								<strong>@{{ value }}</strong>
							</span>
							<span v-if="message" class="invalid-feedback d-flex" role="alert">
								<strong>@{{ message }}</strong>
							</span>
						</div>

					</div>
					<div class="modal-footer">
						<button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
						<button v-if="!loading" type="submit" class="btn btn-primary">@{{ submitButtonName }}</button>
						<button v-if="loading" type="button" class="btn btn-primary" disabled>Loading...</button>
					</div>
				</form>
			</div>
		</div>
	</div>
</section>
@endsection

@push('scripts')
<script type="text/javascript">

	new Vue({
		el: "#app",
		data: {
			categories: @json($categories),
			name: '',
			errors: [],
			loading: false,
			message: '',
			cat_elem: null,
			cat_key: null,
			action: '',
			modalTitle: '',
			submitButtonName: '',
		},
		mounted() {
			$('#category').on('shown.bs.modal', () => {
				$("input[name='name']").trigger('focus');
			});
			$('#category').on('hidden.bs.modal', (event) => {
				this.name = '';
				this.errors = [];
				this.loading = false;
				this.message = '';
				this.cat_elem = {};
				this.cat_key = null;
				this.action = '';
				this.modalTitle = '';
				this.submitButtonName = '';
			});
		},
		methods: {
			openAdd: function() {
				this.submitButtonName = 'Add';
				this.modalTitle = 'Add Category';
				this.action = "{{ route('oversight.categories.store') }}";

				$("#category").modal('show');
			},
			openEdit: function(key) {
				this.cat_key = key;
				this.cat_elem = this.categories[key];
				this.name = this.cat_elem.name;
				this.action = "{{ route('oversight.categories.index') }}/"+this.cat_elem.id;
				this.submitButtonName = 'Edit';
				this.modalTitle = 'Edit Category';

				$("#category").modal('show');
			},
			categoryForm: function (event) {
				this.loading = true;
				event.preventDefault();

				if (this.submitButtonName == 'Edit') {
					axios.put(this.action, {
						name: this.name,
					}).then((response) => {

						this.loading = false;
						this.errors = [];

						let data = response.data;

						this.categories[this.cat_key] = data;
						$("#category").modal('hide');


					}).catch(({ response }) => {
						this.message = '';

						this.loading = false;
						if (response.status == 422) {
							this.errors = response.data.errors;
						} else {
							console.log(response);
							this.message = response.statusText;
						}

					});
				} else {
					axios.post(this.action, {
						name: this.name,
					}).then((response) => {

						this.loading = false;
						this.errors = [];

						let data = response.data;

						this.categories.push(data);
						$("#category").modal('hide');

					}).catch(({ response }) => {
						this.message = '';

						this.loading = false;
						if (response.status == 422) {
							this.errors = response.data.errors;
						} else {
							this.message = response.statusText;
						};

					});
				};

			},
			date_time: function(value) {
				let update_at = new Date(value);
				let date = update_at.toLocaleDateString('en-GB', { day: 'numeric', month: 'short', year: 'numeric' });
				let time = update_at.toTimeString().substr(0,8);

				return date + ' ' +time;
			},
			handle_function_call(function_name) {
				this[function_name]();
			},
		},
	})

</script>
@endpush